<!-- 首页帖子显示列表宏定义 -->
{% macro post_item(posts) %}
    <ul class="list-group">
        {%if not posts%}
            <li class="list-group-item pl-1 ">
                <div class="d-flex ">
                    <div class="flex-grow-1">
                        {% if current_user.role.name == "老师"%}
                            <a class="text-decoration-no<a class="text-decoration-none" href="/post/newt">暂无任何讨论, 快去发布新解答吧!</a>
                        {% else %}
                            <a class="text-decoration-no<a class="text-decoration-none" href="/post/new">暂无任何讨论, 快去发布新讨论吧!</a>
                        {% endif %}
                    </div>
                </div>

            </li>
        {% else %}
        {% for post in posts %}
            <li class="list-group-item pl-1 ">
                <div class="d-flex ">
                    <div class="flex-grow-1">
                        {% if post.star %}
                        <a class="text-decoration-none text-warning mark font-weight-bold " href="{{ url_for('post.read', post_id=post.id) }}"><i class="fa fa-fw fa-diamond mr-2"></i>{{ post.title }}</a>
                        {% else %}
                        <a class="text-decoration-no<a class="text-decoration-none" href="{{ url_for('post.read', post_id=post.id) }}">{{ post.title }}</a>
                        {% endif %}
                        
                        <div class="row mt-2">
                            <div class="col">
                                <p class="mb-0 text-muted f-12">
                                <a class="badge badge-secondary mr-2">{{ post.pro.name }}</a>
                                <i class="fa fa-user-o mr-1"></i>
                                <a class="text-decoration-none" >{{post.user.nickname}}</a>
                            </div>
                        </div>
                    </div>
                </div>

            </li>
        {% endfor %}
        {% endif %}
    </ul>
{% endmacro %}

<!-- 首页帖子显示列表宏定义 -->
{% macro notice_item(notices) %}
    <ul class="list-group">
        {% for notice in notices %}
            <li class="list-group-item pl-1">
                <div class="d-flex">
                    <div class="flex-grow-1">
                        <a class="text-decoration-no<a class="text-decoration-none" href="{{ url_for('notice.read', notice_id=notice.id) }}">{{ notice.title }}</a>
                        <div class="row mt-2">
                            <div class="col">
                                <p class="mb-0 text-muted f-12">
                             
                                <i class="fa fa-user-o mr-1"></i>
                                <a class="text-decoration-none" >{{notice.author_id}}</a>
                            </div>
                        </div>
                    </div>
                </div>

            </li>
        {% endfor %}
    </ul>
{% endmacro %}

{% macro _arg_url_for(endpoint, base) %}
    {# calls url_for() with a given endpoint and **base as the parameters,
   additionally passing on all keyword_arguments (may overwrite existing ones)
 #}
    {%- with kargs = base.copy() -%}
        {%- do kargs.update(kwargs) -%}
        {{ url_for(endpoint, **kargs) }}
    {%- endwith %}
{%- endmacro %}

<!-- 分页渲染 -->
{% macro render_pagination(pagination,
                           endpoint=None,
                           prev=('&laquo;')|safe,
                           next=('&raquo;')|safe,
                           size=None,
                           ellipses='…',
                           args={},
                           fragment='',
                           align=''
                           )-%}
    {% if fragment != '' and not fragment.startswith('#') %}{% set fragment = '#' + fragment %}{% endif %}
    {% with url_args = {} %}
        {%- do url_args.update(request.view_args if not endpoint else {}),
       url_args.update(request.args if not endpoint else {}),
       url_args.update(args) -%}
        {% with endpoint = endpoint or request.endpoint %}
            <nav aria-label="Page navigation">
                <ul class="pagination{% if size %} pagination-{{ size }}{% endif %} {% if align == 'center' %}justify-content-center{% elif align == 'right' %}justify-content-end{% endif %}"{{ kwargs|xmlattr }}>
                    {# prev and next are only show if a symbol has been passed. #}
                    {% if prev != None -%}
                        <li class="page-item {% if not pagination.has_prev %}disabled{% endif %}">
                            <a class="page-link" href="{{ _arg_url_for(endpoint, url_args, page=pagination.prev_num) if pagination.has_prev else '#' }}{{ fragment }}">{{ prev }}</a>
                        </li>
                    {%- endif -%}

                    {%- for page in pagination.iter_pages() %}
                        {% if page %}
                            {% if page != pagination.page %}
                                <li class="page-item">
                                    <a class="page-link" href="{{ _arg_url_for(endpoint, url_args, page=page) }}{{ fragment }}">{{ page }}</a>
                                </li>
                            {% else %}
                                <li class="page-item active">
                                    <a class="page-link" href="#">{{ page }} <span class="sr-only">(current)</span></a>
                                </li>
                            {% endif %}
                        {% elif ellipses != None %}
                            <li class="page-item disabled"><a class="page-link" href="#">{{ ellipses }}</a></li>
                        {% endif %}
                    {%- endfor %}

                    {% if next != None -%}
                        <li class="page-item {% if not pagination.has_next %}disabled{% endif %}">
                            <a class="page-link" href="{{ _arg_url_for(endpoint, url_args, page=pagination.next_num) if pagination.has_next else '#' }}{{ fragment }}">{{ next }}</a>
                        </li>
                    {%- endif -%}
                </ul>
            </nav>
        {% endwith %}
    {% endwith %}
{% endmacro %}

<!-- 显示帖子评论区域宏定义 -->
{% macro commentDiv(comment, post, anonymous=False) %}
    <img src="{{ url_for('static', filename=comment.author.avatar ) }}"  width="50" height="50" class="rounded avatar-50">
    <div class="d-flex">
        <div>
            <a class="ml-2 text-decoration-none" href="#">{{ comment.author.nickname }}</a>
            <div class="d-flex">
                <a class="text-decoration-none ml-2"><span class="badge badge-pill badge-secondary">{{ comment.author.role.name }}</span></a>
                {% if post.author_id == comment.author_id %}
                    <a class="text-decoration-none ml-2"><span class="badge badge-pill badge-info">发起人</span></a>
                {% endif %}
            </div>
        </div>
    </div>
{% endmacro %}